mod imp;

use gtk::gio;
use gtk::glib;
use gtk::prelude::ApplicationExtManual;
use gtk4 as gtk;
use gtk4::prelude::ApplicationExt;

const APP_ID: &str = "de.privacy1st.dndbuster";

glib::wrapper! {
    pub struct CustomApp(ObjectSubclass<imp::CustomApp>)
        @extends gio::Application, gtk::Application,
        @implements gio::ActionMap, gio::ActionGroup;
}

impl CustomApp {
    pub fn new() -> Self {
        glib::Object::builder()
            .property("application-id", APP_ID)
            .property("resource-base-path", "/io/github/seadve/Kooha/")
            .build()
    }

    pub fn run(&self) -> glib::ExitCode {
        eprintln!("Kooha ({})", APP_ID);
        eprintln!("Version: {} ({})", 0.1, "dev");
        eprintln!("Datadir: {}", ".");

        ApplicationExtManual::run(self)
    }

    pub async fn send_record_success_notification(&self) {
        let notification = gio::Notification::new("Screencast recorded");
        notification.set_body(Some("Yeeeeha!"));
        self.send_notification(Some("record-success"), &notification);
    }
}

impl Default for CustomApp {
    fn default() -> Self {
        Self::new()
    }
}
